Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Grid.Grouping

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GridGroupingControl1 As Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.GridGroupingControl1 = New Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl
        CType(Me.GridGroupingControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'GridGroupingControl1
        '
        Me.GridGroupingControl1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GridGroupingControl1.BackColor = System.Drawing.SystemColors.Window
        Me.GridGroupingControl1.Location = New System.Drawing.Point(8, 8)
        Me.GridGroupingControl1.Name = "GridGroupingControl1"
        Me.GridGroupingControl1.Size = New System.Drawing.Size(288, 280)
        Me.GridGroupingControl1.TabIndex = 0
        Me.GridGroupingControl1.Text = "GridGroupingControl1"
        Me.GridGroupingControl1.VersionInfo = "4.101.0.62"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(304, 294)
        Me.Controls.Add(Me.GridGroupingControl1)
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.GridGroupingControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Data Tables"
    Private numberParentRows As Integer = 10
    Private numberChildRows As Integer = 20
    Private Function GetParentTable() As DataTable
        Dim dt As DataTable = New DataTable("ParentTable")


        dt.Columns.Add(New DataColumn("parentID")) 'lower case p
        dt.Columns.Add(New DataColumn("SomeInt"))
        dt.Columns.Add(New DataColumn("SomeText"))

        Dim ran As Random = New Random
        Dim i As Integer = 0
        Do While i < numberParentRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i
            dr(1) = ran.Next(1000)
            dr(2) = "some text"
            dt.Rows.Add(dr)
            i += 1
        Loop

        Return dt
    End Function

    Private Function GetChildTable() As DataTable
        Dim dt As DataTable = New DataTable("ChildTable")

        dt.Columns.Add(New DataColumn("childID")) 'lower case c
        dt.Columns.Add(New DataColumn("ParentID")) 'upper case P
        dt.Columns.Add(New DataColumn("SomeInt"))
        dt.Columns.Add(New DataColumn("SomeText"))
        Dim ran As Random = New Random
        Dim i As Integer = 0
        Do While i < numberChildRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = (i Mod numberParentRows).ToString()
            dr(2) = ran.Next(1000)
            dr(3) = "some text"
            dt.Rows.Add(dr)
            i += 1
        Loop

        Return dt
    End Function

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim parentTable As DataTable = GetParentTable()
        Dim childTable As DataTable = GetChildTable()

        Dim ds As DataSet = New DataSet
        ds.Tables.AddRange(New DataTable() {parentTable, childTable})

        Dim parentToChild As DataRelation = New DataRelation("ParentToChild", parentTable.Columns("parentID"), childTable.Columns("ParentID"))
        ds.Relations.Add(parentToChild)

        Me.GridGroupingControl1.DataSource = ds.Tables(0)

        Me.GridGroupingControl1.TableModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll
        Dim gridChildTable As GridTable = Me.GridGroupingControl1.GetTable("ChildTable")
        gridChildTable.TableModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll

    End Sub
End Class
